<?php

namespace App\Http\Controllers;

use App\Models\Plant;
use Illuminate\Http\Request;

class ModulePlantController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    public function get_modulePlant(Request $request)
    {
        $expectedUser = env('API_AUTH_USER');
        $expectedPw   = env('API_AUTH_PW');

        $header_auth = $request->header('Authorization');
        $expectedToken = $expectedUser . ':' . $expectedPw;

        if ("Bearer " . $expectedToken != $header_auth)
        {
            return response()->json([
                'status_code' => 'ERROR',
                'status_description' => 'Invalid authorization token!'
            ], 403);
        }

        $plantName = $request->header('plant-name');

        if (empty($plantName))
        {
            return response()->json([
                'status_code' => 'ERROR',
                'status_description' => "Plant Name can't be empty!"
            ], 404);
        }

        $headerValue = $request->header('plant-name');

        if ($headerValue != 'Plant List') {
            return response()->json([
                'status_code' => 'ERROR',
                'status_description' => "Invalid value for 'plant-name' header!"
            ], 404);
        }

        $plantNames = Plant::orderBy('created_at', 'asc')
        ->pluck('name')
        ->values();

        return response()->json([
            'status_code' => 'SUCCESS',
            'status_description' => $plantNames
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }
}
